UUX(1C)

NAME
uux - remote system command execution

SYNOPSIS
uux [ - ] [ -bcCjnprz ] [ -aname ] [ -ggrade ]
[ -x debug_level ] command-string

AVAILABILITY

This command is available with the uucp software installation option. Refer to for information on how to install optional software.

DESCRIPTION

uux will gather 0 or more files from various systems, execute a command on a specified system and send the standard output to a file on a specified system.

For security reasons, most installations limit the list of commands executable on behalf of an incoming request from uux, permitting only the receipt of mail (see mail(1)). Remote execution permissions are defined in /etc/uucp/Permissions.

The command-string is made up of one or more arguments that look like a shell command line, except that the command and file names may be prefixed by `system-name!'. A null system-name is interpreted as the local system.

Path names may be one of:

    •   a full pathname;

    •   a pathname preceded by ~username/; username is interpreted as a username on the specified system and is replaced by that user's login directory on that system;

    •   a pathname preceded by ~/destination/; the ~/ is replaced by the “public UUCP” directory on the remote machine Note: this destination will be treated as a file name unless more than one file is being transferred by this request or the destination is already a directory. To ensure that it is a directory, follow the destination with a '/'. For example ~/dan/ as the destination will make the directory /usr/spool/uucppublic/dan if it does not exist and put the requested file(s) in that directory;

    •   a partial pathname, which is prefixed by the pathname of current directory.

The `-' option sends the standard input to the uux command as the standard input to the command-string.

Any special shell characters such as <>, ;, and | should be quoted either by quoting the entire command-string, or by quoting the special characters as individual arguments.

uux will attempt to get all files to the execution system. For files that are output files, the file name must be escaped using parentheses. For example, the command

    uux a!cut -f1 b!/usr/file \(c!/usr/file\)

gets /usr/file from system b and sends it to system a, performs a cut command on that file and sends the result of the cut command to system c.

uux will notify you if the requested command on the remote system was disallowed, or if the command fails (that is, returns a non-zero exit status). This notification can be turned off by the -n option. The response comes by remote mail from the remote machine.

OPTIONS

-b  Return whatever standard input was provided to the uux command if the job fails (that is, returns a non-zero exit status).

-c  Do not copy local file to the spool directory for transfer to the remote machine. This is the default.

-C  Force the copy of local files to the spool directory for transfer.

-j  Output the jobid ASCII string on the standard output which is the job identification. This job identification can be used by uustat(1C) to obtain the status or terminate a job.

-n  Do not return any indication by mail(1) of success or failure of the job.

-p  Same as `-': the standard input to uux is made the standard input to the command-string.

-r  Do not start uucico(8C), just queue the job.

-z  Return an indication by mail even if the job succeeds (that is, returns a zero exit status).

-aname
    Use name as the user identification replacing the initiator user ID. Notification will be returned to the user.

-ggrade
    grade is a single letter or number, from 0 to 9, A to Z, or a to z; 0 is the highest grade, and z is the lowest grade. Lower grades will transmit the job earlier during a particular conversation. The default grade is A.

-x debug_level
    Produce debugging output on the standard output. debug_level is a number between 0 and 9; higher numbers give more detailed information. 5, 7, and 9 are good numbers to try; they give increasing amounts of detail.

EXAMPLE

The command

    uux "!diff usg!/usr/dan/file1 pwba!/a4/dan/file2 > !~/dan/file.diff"

will get the file1 and file2 files from the usg and pwba machines, execute a diff(1) command and put the results in file.diff in the local PUBDIR/dan directory.

FILES
/var/spool/uucp
    spool directories
/etc/uucp/Permissions
    remote execution permissions
/etc/uucp/*
    other data
/usr/lib/uucp/*
    other programs

SEE ALSO
mail(1), uucp(1C), uustat(1C), uucico(8C)

WARNINGS

Only the first command of a shell pipeline may have a `system-name!'. All other commands are executed on the system of the first command.

The use of the shell metacharacter * will probably not do what you want it to do.

The shell tokens << and >> are not implemented.

The execution of commands on remote systems takes place in an execution directory known to the UUCP system. All files required for the execution will be put into this directory unless they already reside on that machine. Therefore, the simple file name (without path or machine reference) must be unique within the uux request. The following command will NOT work:

    uux "a!diff b!/usr/dan/xyz c!/usr/dan/xyz > !xyz.diff"

but the command

    uux "a!diff a!/usr/dan/xyz c!/usr/dan/xyz > !xyz.diff"

will work (if diff is a permitted command).

When invoking uux from csh(1), the ! character must be prefixed by the \ escape to inhibit csh's history mechanism. Quotes are not sufficient.

BUGS

Protected files and files that are in protected directories that are owned by the requestor can be sent in commands using uux. However, if the requestor is root, and the directory is not searchable by “other”, the request will fail.